CON
  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000

  
  PING_Pin = 16                                                                 'PING))) I/O Pin
  AF_Pin = 24                                                                   'MOTOR A Pin
  BF_Pin = 26                                                                   'MOTOR B Pin
  default_speed = 40                                                            'Default driving speed
  MAX_RANGE = 100                                                               ' Maximum range for object detection in centimeters

                                                                                ''******Autonomous robot code****By 'Botdoctor'*******''
                                                                                '' Motor A = Left                                     ''
                                                                                '' Motor B = Right                                    ''
                                                                                '' Just use IF functions to drive the robot on sensors''
                                                                                '' Example: if range < 40                             ''
                                                                                ''            TURNLEFT                                ''
                                                                                ''            <..more code..>                         ''
  
VAR
  long  range
  long  aspeed
  long  bspeed
  
OBJ
  PWM     : "PWM_32_v2.spin"
  ping    : "ping"
 
PUB Main | DutyCycle
 
    PWM.Start                                                                   ' Initialize PWM cog. This Block Starts the PWM Object
    
  repeat      
      range := ping.Centimeters(PING_Pin)                                       'Get Range In Millimeters
      aspeed := default_speed                                                   'Speed of motor a
      bspeed := default_speed                                                   'Speed of motor b
      PWM.Duty(AF_Pin,aspeed,16665)                                             'Drive forward in default speed
      PWM.Duty(BF_Pin,bspeed,16665)
      
'  Do nothing when range is higher than 1meter      
      IF range > MAX_RANGE
        range := MAX_RANGE
        aspeed := aspeed
        bspeed := bspeed
        PWM.Duty(AF_Pin,aspeed,16665)                                           'Drive forward in Maximum range speed
        PWM.Duty(BF_Pin,bspeed,16665)
        
'  Slow down when in range                 
      IF range < MAX_RANGE                                                            
        aspeed := (range / 3) * 2                                               'Drive speed is calculated here 
        bspeed := (range / 3) * 2
        PWM.Duty(AF_Pin,aspeed,16665)                                           'Drive forward slowing speed down lineair to range
        PWM.Duty(BF_Pin,bspeed,16665)

      IF range < 40
        SetField( x_pos, y_pos - sectordist, 2 )                                'Scan north or towards front and adjust sector bit if object is detected
        TURNRIGHT
      ELSEIF range < 30
        SetField( x_pos, y_pos - sectordist, 2 )
        TURNLEFT       
      ELSEIF range < 20
        SetField( x_pos, y_pos - sectordist, 2 )
        REVERSE
        TURNLEFT
      
         
PUB TURNRIGHT | DutyCycle      
'      Avoid obstacle turn RIGHT       
        PWM.Duty(AF_Pin,40,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin+1,40,16665)                                                       'Create a 60Hz 50% duty cycle on Pin2
        repeat 450000
        PWM.Duty(AF_Pin,0,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin+1,0,16665)
        PWM.Duty(AF_Pin,0,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin,0,16665)
RETURN
              
PUB TURNLEFT | DutyCycle
'      Avoid obstacle turn LEFT       
        PWM.Duty(AF_Pin+1,40,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin,40,16665)                                                       'Create a 60Hz 50% duty cycle on Pin2
        repeat 600000
        PWM.Duty(AF_Pin+1,0,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin,0,16665)
        PWM.Duty(AF_Pin,0,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin,0,16665)
RETURN
        
PUB FORWARD | DutyCycle
'     Drive FORWARD       
        PWM.Duty(AF_Pin,60,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin,60,16665)                                                       'Create a 60Hz 50% duty cycle on Pin2
        repeat 450000
        PWM.Duty(AF_Pin,0,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin,0,16665)   
RETURN
               
PUB REVERSE | DutyCycle
'     Drive REVERSE      
        PWM.Duty(AF_Pin+1,40,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin+1,40,16665)                                                       'Create a 60Hz 50% duty cycle on Pin2
        repeat 450000
        PWM.Duty(AF_Pin+1,0,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin+1,0,16665)
        PWM.Duty(AF_Pin,0,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin,0,16665) 
RETURN

PUB STOP | DutyCycle
'     STOP Driving
        PWM.Duty(AF_Pin,0,16665)                                                       'Create a 60Hz 50% duty cycle on Pin1
        PWM.Duty(BF_Pin,0,16665)
        repeat 600000
RETURN
